

#ifndef OLAF_EP_EXTRACTOR_H
#define OLAF_EP_EXTRACTOR_H

	#include "olaf_config.h"
	
	//an event point is a combination of a frequency bin and time bin
	//the magnitude 
	struct eventpoint {
		int frequencyBin;
		int timeIndex;
		float fractionalFrequencyBin;
		float magnitude;
		int printsPerPoint;
	};

	//this is shared with the interface to the outside
	struct extracted_event_points{
		struct eventpoint * eventPoints;
		int eventPointIndex;
	};
	
	typedef struct Olaf_EP_Extractor Olaf_EP_Extractor;

	Olaf_EP_Extractor * olaf_ep_extractor_new(Olaf_Config * config);

	struct extracted_event_points * olaf_ep_extractor_extract(Olaf_EP_Extractor *, float* fft_magnitudes, int audioBlockIndex);

	//free memory resources and 
	void olaf_ep_extractor_destroy(Olaf_EP_Extractor * );


#endif // OLAF_EP_EXTRACTOR_H
