#include <driver/i2s.h>

#define I2S_WS 0 // or frame select or LeftRight Clock (LRC
#define I2S_SD 4// DOUT
#define I2S_SCK 17// or Bit Clock BCLK

void i2s_setpin(){
  const i2s_pin_config_t pin_config = {
    .bck_io_num = I2S_SCK,
    .ws_io_num = I2S_WS,
    .data_out_num = I2S_PIN_NO_CHANGE,
    .data_in_num = I2S_SD
  };

  i2s_set_pin(I2S_NUM_0, &pin_config);
}

void i2s_install(){
  const i2s_config_t i2s_config = {
    .mode = i2s_mode_t(I2S_MODE_MASTER | I2S_MODE_RX),
    .sample_rate = 8000,
    .bits_per_sample = i2s_bits_per_sample_t(32),
    .channel_format = I2S_CHANNEL_FMT_ONLY_RIGHT,
    .communication_format = i2s_comm_format_t(I2S_COMM_FORMAT_I2S | I2S_COMM_FORMAT_I2S_MSB),
    .intr_alloc_flags = 0, // default interrupt priority
    .dma_buf_count = 8,
    .dma_buf_len = 128,
    .use_apll = false
  };

  i2s_driver_install(I2S_NUM_0, &i2s_config, 0, NULL);
}

void setupSound(){

  pinMode(16,OUTPUT);
  pinMode(2,OUTPUT);
  digitalWrite(16,LOW);//gnd connector
  digitalWrite(2,HIGH);//Select left

  delay(1000);
  i2s_install();
  i2s_setpin();
  i2s_start(I2S_NUM_0);

}
